package ex2;

import java.lang.reflect.Field;

import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.FieldSignature;

@Aspect
public class FieldSetAspect {

    @Pointcut("args(rhs) && set(java.lang.String ex2.Address.*)")
    public void allFields(Object rhs) {
    }

    @Around("allFields(rhs)")
    public Object reportFieldAssignment(ProceedingJoinPoint thisJoinPoint,
            Object rhs) throws Throwable {
        FieldSignature fs = (FieldSignature) thisJoinPoint.getSignature();

        Object target = thisJoinPoint.getTarget();
        Field field = fs.getField();
        field.setAccessible(true);
        Object currentValue = field.get(target);
        System.out.printf("Setting %s from %s to %s\n", fs.getName(),
                currentValue, rhs);

        return thisJoinPoint.proceed();
    }
}
